=== debian/changelog ===
zeromq3 (4.3.1.2-1) unstable; urgency=medium

  * update

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 28 Jul 2021 14:03:01 +0800

zeromq3 (4.3.1.1-1+eagle) unstable; urgency=medium

  * update

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 16 Nov 2020 12:03:05 +0800

zeromq3 (4.3.1-4+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * zeromq connects peer before handshake is completed (CVE-2020-15166)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 06 Sep 2020 13:22:41 +0200

zeromq3 (4.3.1-4+deb10u1) buster-security; urgency=high

  [ Luca Boccassi <bluca@debian.org> ]
  * Fix CVE-2019-13132: application metadata not parsed correctly when using
    CURVE.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 06 Jul 2019 14:13:37 +0000

zeromq3 (4.3.1-4) unstable; urgency=medium

  [ Luca Boccassi <bluca@debian.org> ]
  * Fix GSSAPI support build (closes: #925914).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 28 Mar 2019 16:37:09 +0000
