=== debian/changelog ===
zeromq3 (4.3.2-2ubuntu1) focal; urgency=medium

  * Fix test_hwm_pubsub on slow platforms like riscv64. Patch from an unmerged
    upstream PR.

 -- William Grant <wgrant@ubuntu.com>  Tue, 21 Apr 2020 11:21:58 +1000

zeromq3 (4.3.2-2) unstable; urgency=medium

  * Sync zmq.hpp from cppzmq (closes: #951135).
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 20 Feb 2020 20:12:19 +0000

zeromq3 (4.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Remove backported patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 25 Jul 2019 21:38:04 +0000

zeromq3 (4.3.1-5) unstable; urgency=high

  [ Luca Boccassi <bluca@debian.org> ]
  * Fix CVE-2019-13132: application metadata not parsed correctly when using
    CURVE.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 06 Jul 2019 13:52:23 +0000
