=== debian/rules ===
--- 
+++ 
@@ -21,14 +21,13 @@
 		--with-libgssapi_krb5=yes
 
 override_dh_auto_test:
-
-#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-#ifneq ($(DO_TEST), no)
-#	dh_auto_test -- VERBOSE=1
-#else
-#	-dh_auto_test -- VERBOSE=1
-#endif
-#endif
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+ifneq ($(DO_TEST), no)
+	dh_auto_test -- VERBOSE=1
+else
+	-dh_auto_test -- VERBOSE=1
+endif
+endif
 
 %:
 	dh $@ --with=autoreconf
