=== debian/changelog ===
zeromq3 (4.3.4-1) unstable; urgency=medium

  * New upstream release.
  * Remove backported patches.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 03 Feb 2021 08:46:36 +0100

zeromq3 (4.3.3-6) unstable; urgency=medium

  * Backport upstream fix for:
    - another FTBFS on kFreeBSD (closes: #979175).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 09 Jan 2021 14:46:20 +0100

zeromq3 (4.3.3-5) unstable; urgency=medium

  * Backport upstream fix for:
    - FTBFS on kFreeBSD (closes: #979175).
  * Add special license exception granted by copyright holders
    (closes: #977662).
  * Update packaging bits.
  * Sync with Ubuntu.

  [ Matthias Klose <doko@ubuntu.com> ]
  * Fix test_hwm_pubsub on slow platforms like riscv64. Patch from an
    unmerged upstream PR.
  * Fix ftbfs on s390x (which appears to inline more aggressively than on
    other architectures).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 07 Jan 2021 19:10:33 +0100

zeromq3 (4.3.3-4) unstable; urgency=medium

  * Add missed libbsd-dev dependency to libzmq3-dev (closes: #975151).
  * Backport upstream fix of tests fails to receive on slow architectures.

  [ Svante Signell <svante.signell@gmail.com> ]
  * Fix FTBFS on Hurd-i386 (closes: #975100).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 19 Nov 2020 11:27:16 +0100

zeromq3 (4.3.3-3) unstable; urgency=medium

  * Build depend on libbsd-dev for better strlcpy() implementation
    (closes: #974605).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 18 Nov 2020 11:51:12 +0100

zeromq3 (4.3.3-2) unstable; urgency=medium

  * Backport upstream fix of broken zmq_ctx_get API.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 11 Sep 2020 14:55:46 +0200

zeromq3 (4.3.3-1) unstable; urgency=high

  * New upstream release:
    - fixes CVE-2020-15166: Denial-of-Service on CURVE/ZAP-protected servers
      by unauthenticated clients.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 07 Sep 2020 18:10:59 +0200
