=== debian/control ===
Source: zeromq3
Section: devel
Priority: optional
Maintainer: Valdur Palm <vpalm@perforce.com>
Build-Depends: debhelper
Build-Depends-Indep:

Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://zeromq.org/
Package: libzmq5-zendphp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight messaging kernel (shared library)

Package: libzmq3-zendphp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libzmq5-zendphp (= ${binary:Version}), libbsd-dev
Description: lightweight messaging kernel (development files)
